<template>
  <div>
    <client-only>
      <div class="finished-bubble">
        <h2>Nice work!</h2>
        <p>
          You finished {{ courseName }}, checking in
          {{ checkins.length }} times, in
          {{ (endTime - startTime) | formatElapsed }}!
        </p>
        <error-view v-if="error" :error="error" />
        <p v-if="syncing">Syncing with server...<loading-dots /></p>
        <p v-if="netError">
          We're experiencing some trouble with the network. Make sure you're
          near cell service or WiFi.
          <br />

          <stateful-button @click="sync">Try again</stateful-button>
        </p>
        <p v-else-if="synced">
          <button class="button" @click="exit">Back to home</button>
        </p>
      </div>
    </client-only>

    <client-only>
      <portal to="map">
        <Checkpoint
          v-for="cp in checkpoints"
          :key="cp.key"
          :value="cp"
          :visited="visited(cp)"
        />
        <MglGeojsonLayer
          source-id="finished-source"
          :source="geojson"
          layer-id="finished-layer"
          :layer="style"
        />
        <MglConfig :items="checkpoints" />
      </portal>
    </client-only>
  </div>
</template>
<script>
import { get } from "~/lib/utils";
import { mapState } from "vuex";
import MglConfig from "~/components/mapping/MglConfig";
import Checkpoint from "~/components/mapping/Checkpoint";

export default {
  components: { MglConfig, Checkpoint },
  data() {
    return {
      error: null,
      syncing: false,
      synced: false,
      geojson: {
        type: "geojson",
        data: { type: "FeatureCollection", features: [] },
      },
    };
  },
  watch: {
    events: {
      immediate: true,
      handler() {
        this.geojson = {
          type: "geojson",
          data: {
            type: "Feature",
            properties: {},
            geometry: {
              type: "MultiPoint",
              coordinates: this.events.map((e) => [e.lng, e.lat]),
            },
          },
        };
      },
    },
  },
  mounted() {
    this.sync();
  },
  computed: {
    ...mapState({
      courseId: (state) => state.run.courseId,
      courseName: (state) => state.run.courseName,
      runId: (state) => state.run.id,
      checkpoints: (state) => state.run.checkpoints,
      events: (state) => state.run.events,
      checkins: (state) => state.run.checkins,
      startTime: (state) => state.run.start && new Date(state.run.start),
      endTime: (state) => state.run.end && new Date(state.run.end),
      netError: (state) => state.run.netError,
    }),

    style() {
      return {
        type: "circle",
        source: "finished-source",
        paint: {
          "circle-radius": 2.5,
          "circle-color": "blue",
          "circle-opacity": 0.4,
        },
      };
    },
  },
  methods: {
    exit() {
      this.$store.commit("run/reset");
      this.$router.push("/");
    },
    async sync() {
      this.error = null;
      try {
        this.syncing = true;
        await this.$store.dispatch("run/sync");
      } catch (x) {
        this.error = x;
      } finally {
        this.syncing = false;
        this.synced = !this.$store.state.run.netError;
      }
    },
    visited(cp) {
      return (
        this.checkins && !!this.checkins.find((v) => v.checkpointId == cp.id)
      );
    },
  },
};
</script>
<style lang="scss" scoped>
@import "~assets/mixins";

.finished-bubble {
  pointer-events: initial;
  background-color: $color-background;
}
</style>
